%define gcc_version 4.1.1
%define _unpackaged_files_terminate_build 1
Summary: SPU cross-compiler
Name: spu-gcc
Version: %{gcc_version}
Release: 107
License: GPL
Group: Cell Development Tools
Requires: spu-binutils = 2.17.50
AutoProv: no
AutoReq: no
Source0: gcc-r886.tar.bz2
# Not yet applied to FSF or 3C.
Patch1: common-sysroot.diff
# Not in FSF or 3C. Only applied for fortran support.
Patch2: no-timode.diff
# Not yet in FSF or 3C.
Patch3: tag-manager.diff
# Not yet in FSF or 3C.
Patch4: ea-frontend.diff
# Not yet in FSF or 3C.
Patch5: cache.diff
# Not yet in FSF or 3C.
Patch6: ea-dwarf.diff
# Not yet in FSF or 3C.
Patch7: ea-backend.diff
# Not yet in FSF or 3C.
Patch8: multilib.diff
# Not yet in FSF or 3C.
Patch9: pointer-cast.diff 
# Not yet in FSF or 3C.
Patch10: pr36096.diff
# Not yet in FSF or 3C.
Patch11: mem_alias.diff
# Not yet in FSF or 3C.
Patch12: convert.diff
# Not yet in FSF or 3C.
Patch13: pr38063.diff
# Not yet in FSF or 3C.
Patch14: pr38063-2.diff
# In FSF and 3C.
Patch15: vect-fixes.diff
# In FSF and 3C.
Patch16: vect-fixes-tests.diff
# Not yet in FSF or 3C.
Patch17: ea-dirty.diff
# Not yet in FSF or 3C.
Patch18: ea-const-compare.diff
# Not yet in FSF, but in 3C.
Patch19: pr38589.diff

# None of these yet applied to FSF:
#   rfc00067.diff
#   pr27318.diff
#   bigspu.diff

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: zlib-devel, dejagnu, bison, flex, texinfo, spu-binutils, spu-newlib

# Don't strip as the host binutils may be unable to handle SPU objects.
%define __os_install_post /usr/lib/rpm/brp-compress

# When building the cross-toolchain, reset prefix directory and use sysroot
%ifnarch ppc ppc64
%define _prefix /opt/cell/toolchain
%define _mandir %{_prefix}/man
%define _infodir %{_prefix}/info
%define with_sysroot --with-sysroot=/opt/cell/sysroot
%endif

%description 
GNU Compiler Collection for Cell Broadband Engine SPU.

%package -n spu-gcc-c++
Summary: C++ support for SPU cross-compiler
Group: Cell Development Tools
Requires: spu-gcc = %{version}-%{release}
AutoProv: no
AutoReq: no

%description -n spu-gcc-c++
GNU Compiler Collection C++ compiler for Cell Broadband Engine SPU.

%package -n spu-gcc-fortran
Summary: Fortran support for SPU cross-compiler
Group: Cell Development Tools
Requires: spu-gcc = %{version}-%{release}
AutoProv: no
Autoreq: no

%description -n spu-gcc-fortran
GNU Compiler Collection Fortran compiler for Cell Broadband Engine SPU.

%package testsuite
Summary: DejaGnu testsuite for SPU cross-compiler
Group: Cell Development Tools
Requires: spu-gcc = %{version}-%{release}, dejagnu
AutoProv: no
AutoReq: no

%description testsuite
DejaGnu testsuite for the Cell Broadband Engine SPU version of GCC.

%prep
%setup -c -q
%patch1 -p0
%patch2 -p0
%patch3 -p0
%patch4 -p0
%patch5 -p0
%patch6 -p0
%patch7 -p0
%patch8 -p0
%patch9 -p0
%patch10 -p0
%patch11 -p0
%patch12 -p0
%patch13 -p0
%patch14 -p0
%patch15 -p0
%patch16 -p0
%patch17 -p0
%patch18 -p0
%patch19 -p0

pushd toolchain/gcc
./contrib/gcc_update --touch
popd

%build

%define spu_target_platform spu
%define spu_prefix spu-

rm -fr obj-%{spu_target_platform}
mkdir obj-%{spu_target_platform}
cd obj-%{spu_target_platform}

OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g'`
SPU_OPT_FLAGS="-O2 -g -pipe -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64"
CC="gcc $OPT_FLAGS"
CC="$CC" CFLAGS="$SPU_OPT_FLAGS" CXXFLAGS="$SPU_OPT_FLAGS" XCFLAGS="$OPT_FLAGS" TCFLAGS="$SPU_OPT_FLAGS" \
	../toolchain/gcc/configure --prefix=%{_prefix} --mandir=%{_mandir} --infodir=%{_infodir} \
	%{?with_sysroot} \
	--disable-shared --disable-threads --disable-checking --with-headers \
	--with-system-zlib --with-newlib \
	--enable-languages=c,c++,fortran --disable-nls \
	--enable-version-specific-runtime-libs --disable-libssp \
	--program-prefix=%{spu_prefix} \
	--target=%{spu_target_platform}

make %{?_smp_mflags}

%install
rm -fr $RPM_BUILD_ROOT

cd obj-%{spu_target_platform}
TARGET_PLATFORM=%{spu_target_platform}

make DESTDIR=$RPM_BUILD_ROOT install

# "Install" the testsuite and the test_installed script.
cp -r $RPM_BUILD_DIR/spu-gcc-%{gcc_version}/toolchain/gcc/gcc/testsuite $RPM_BUILD_ROOT%{_prefix}/share/spu-gcc-testsuite
install -m 755 $RPM_BUILD_DIR/spu-gcc-%{gcc_version}/toolchain/gcc/contrib/test_installed $RPM_BUILD_ROOT%{_prefix}/share/spu-gcc-testsuite
install -D -m 644 $RPM_BUILD_DIR/spu-gcc-%{gcc_version}/toolchain/gcc/contrib/cell-native.exp $RPM_BUILD_ROOT/usr/share/dejagnu/baseboards/cell-native.exp
install -D -m 644 $RPM_BUILD_DIR/spu-gcc-%{gcc_version}/toolchain/gcc/contrib/cell-remote.exp $RPM_BUILD_ROOT/usr/share/dejagnu/baseboards/cell-remote.exp

FULLPATH=$RPM_BUILD_ROOT%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}

# fix some things
ln -sf %{spu_prefix}gcc $RPM_BUILD_ROOT%{_prefix}/bin/%{spu_prefix}cc
#rm -f $RPM_BUILD_ROOT%{_infodir}/dir
#gzip -9 $RPM_BUILD_ROOT%{_infodir}/*.info*
rm -f $RPM_BUILD_ROOT%{_prefix}/bin/%{spu_prefix}gcc-%{gcc_version}
rm -f $RPM_BUILD_ROOT%{_prefix}/bin/%{spu_prefix}gccbug
rm -f $RPM_BUILD_ROOT%{_prefix}/lib/libiberty.a
rm -f $RPM_BUILD_ROOT%{_prefix}/lib/libmmalloc.a
rm -f $RPM_BUILD_ROOT%{_prefix}/%{spu_target_platform}/lib/libiberty.a
rm -f $RPM_BUILD_ROOT%{_prefix}/%{spu_target_platform}/lib/mea64/libiberty.a

rm -rf $RPM_BUILD_ROOT%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/install-tools
rm -rf $RPM_BUILD_ROOT%{_prefix}/libexec/gcc/%{spu_target_platform}/%{gcc_version}/install-tools

rm -f $RPM_BUILD_ROOT%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/*.la
rm -f $RPM_BUILD_ROOT%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/mea64/*.la

for h in `find $FULLPATH/include -name \*.h`; do
  if grep -q 'It has been auto-edited by fixincludes from' $h; then
    rh=`grep -A2 'It has been auto-edited by fixincludes from' $h | tail -1 | sed 's|^.*"\(.*\)".*$|\1|'`
    diff -up $rh $h || :
    rm -f $h
  fi
done

cat > $RPM_BUILD_ROOT%{_prefix}/bin/%{spu_prefix}c89 <<"EOF"
#!/bin/sh
fl="-std=c89"
for opt; do
  case "$opt" in
    -ansi|-std=c89|-std=iso9899:1990) fl="";;
    -std=*) echo "`basename $0` called with non ANSI/ISO C option $opt" >&2
	    exit 1;;
  esac
done
exec %{_prefix}/bin/%{spu_prefix}gcc $fl ${1+"$@"}
EOF
cat > $RPM_BUILD_ROOT%{_prefix}/bin/%{spu_prefix}c99 <<"EOF"
#!/bin/sh
fl="-std=c99"
for opt; do
  case "$opt" in
    -std=c99|-std=iso9899:1999) fl="";;
    -std=*) echo "`basename $0` called with non ISO C99 option $opt" >&2
	    exit 1;;
  esac
done
exec %{_prefix}/bin/%{spu_prefix}gcc $fl ${1+"$@"}
EOF
chmod 755 $RPM_BUILD_ROOT%{_prefix}/bin/%{spu_prefix}c?9
cat > $RPM_BUILD_ROOT%{_prefix}/bin/%{spu_prefix}gcc-runtests <<"EOF"
#!/bin/sh
function usage { echo "Usage: $0 native | remote <hostname>"; exit 1; }
test $# -eq 0 && usage
test $1 = native -o \( $1 = remote -a $# = 2 \) || usage
test $1 = remote && export GCC_TARGET_HOSTNAME=$2
if [ $1 = native ] ; then board=cell-native; else board=cell-remote; fi
bin=%{_prefix}/bin
exec %{_prefix}/share/spu-gcc-testsuite/test_installed --with-testsuite=%{_prefix}/share/spu-gcc-testsuite --with-gcc=$bin/spu-gcc --with-g++=$bin/spu-g++ --with-gfortran=$bin/spu-gfortran --without-objc --target spu-unknown-elf --target_board $board
EOF
chmod 755 $RPM_BUILD_ROOT%{_prefix}/bin/%{spu_prefix}gcc-runtests

# Info and man7 files conflict with host toolchain files, 
# just remove them for now.
rm -rf $RPM_BUILD_ROOT%{_infodir}
rm -rf $RPM_BUILD_ROOT%{_mandir}/man7

cd ..

%clean
rm -rf $RPM_BUILD_ROOT

%files -n spu-gcc
%defattr(-,root,root)
%dir %{_prefix}
%dir %{_prefix}/bin
%dir %{_mandir}
%dir %{_mandir}/man1
%{_prefix}/bin/%{spu_prefix}cc
%{_prefix}/bin/%{spu_prefix}c89
%{_prefix}/bin/%{spu_prefix}c99
%{_prefix}/bin/%{spu_prefix}gcc
%{_prefix}/bin/%{spu_prefix}gcov
%{_prefix}/bin/%{spu_prefix}cpp
%{_mandir}/man1/%{spu_prefix}gcc.1*
%{_mandir}/man1/%{spu_prefix}gcov.1*
%{_mandir}/man1/%{spu_prefix}cpp.1*
%dir %{_prefix}/libexec
%dir %{_prefix}/libexec/gcc
%dir %{_prefix}/libexec/gcc/%{spu_target_platform}
%dir %{_prefix}/libexec/gcc/%{spu_target_platform}/%{gcc_version}
%{_prefix}/libexec/gcc/%{spu_target_platform}/%{gcc_version}/cc1
%{_prefix}/libexec/gcc/%{spu_target_platform}/%{gcc_version}/collect2
%dir %{_prefix}/lib
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{spu_target_platform}
%dir %{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include/stddef.h
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include/stdarg.h
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include/varargs.h
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include/float.h
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include/limits.h
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include/syslimits.h
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include/stdbool.h
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include/iso646.h
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include/unwind.h
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include/spu_*.h
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include/vmx2spu.h
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include/vec_types.h
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include/README
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/crt*.o
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/libgcc.a
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/libgcov.a
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/libgcc_*.a
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/mea64/crt*.o
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/mea64/libgcc.a
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/mea64/libgcov.a
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/mea64/libgcc_*.a

%files -n spu-gcc-c++
%defattr(-,root,root)
%dir %{_prefix}
%dir %{_prefix}/bin
%dir %{_mandir}
%dir %{_mandir}/man1
%{_prefix}/bin/%{spu_prefix}g++
%{_prefix}/bin/%{spu_prefix}c++
%{_mandir}/man1/%{spu_prefix}g++.1*
%dir %{_prefix}/lib
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{spu_target_platform}
%dir %{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include
%dir %{_prefix}/libexec
%dir %{_prefix}/libexec/gcc
%dir %{_prefix}/libexec/gcc/%{spu_target_platform}
%dir %{_prefix}/libexec/gcc/%{spu_target_platform}/%{gcc_version}
%{_prefix}/libexec/gcc/%{spu_target_platform}/%{gcc_version}/cc1plus
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/libstdc++.a
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/libsupc++.a
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/mea64/libstdc++.a
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/mea64/libsupc++.a
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include/c++

%files -n spu-gcc-fortran
%defattr(-,root,root)
%dir %{_prefix}
%dir %{_prefix}/bin
%dir %{_mandir}
%dir %{_mandir}/man1
%{_prefix}/bin/%{spu_prefix}gfortran
%{_mandir}/man1/%{spu_prefix}gfortran.1*
%dir %{_prefix}/lib
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{spu_target_platform}
%dir %{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/include
%dir %{_prefix}/libexec
%dir %{_prefix}/libexec/gcc
%dir %{_prefix}/libexec/gcc/%{spu_target_platform}
%dir %{_prefix}/libexec/gcc/%{spu_target_platform}/%{gcc_version}
%{_prefix}/libexec/gcc/%{spu_target_platform}/%{gcc_version}/f951
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/libgfortran.a
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/libgfortranbegin.a
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/mea64/libgfortran.a
%{_prefix}/lib/gcc/%{spu_target_platform}/%{gcc_version}/mea64/libgfortranbegin.a

%files testsuite
%defattr(-,root,root)
%dir %{_prefix}
%dir %{_prefix}/bin
%dir %{_prefix}/share
%{_prefix}/bin/%{spu_prefix}gcc-runtests
%{_prefix}/share/%{spu_prefix}gcc-testsuite
%dir /usr/share/dejagnu/baseboards
/usr/share/dejagnu/baseboards/cell-native.exp
/usr/share/dejagnu/baseboards/cell-remote.exp

%changelog
* Fri Sep 11 2007  Sa Liu  <saliu@de.ibm.com>  4.1.1-107
- Fix PR 38589 Generate inline code for int to double conversion by default,
  and call libgcc function with -Os.

* Fri Sep 7 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-106
- Fix comparisons between integer constants and __ea pointers.

* Fri Sep 7 2007  Alan Modra  <amodra@au1.ibm.com>  4.1.1-105
- Call __cache_fetch_dirty on inline __ea writes that miss.
- Properly set up library call sym refs.
- Fix a couple of places where pointers were assumed to be ptr_mode or
  Pmode (both SImode for spu).  -mea64 __ea pointers are DImode.
- Use .quad and .8byte for DImode output, which are perfectly good if
  32-bit assembler is built with --enable-64-bit-bfd.

* Thu Sep 6 2007  Ira Rosen  <irar@il.ibm.com>  4.1.1-104
- Backport vectorizer related fixes.

* Thu Sep 6 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-103
- Refresh convert.diff and pointer-cast.diff patches having audited
  all uses of the POINTER_SIZE macro.

* Wed Aug 29 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-102
- Roll forward to gcc-r886.tar.bz2.
- Remove celledp-more.diff, libcall.diff, peelfix.diff, pr35978.diff,
  pr36596.diff.

* Tue Aug 28 2007  Ulrich Weigand  <uweigand@de.ibm.com>  4.1.1-101
- Fix ivopts problem with __ea pointer IV variables.  (#38063)
- Fix inline-generated __ea access code.  (#38063)
- Fix -mea64 cache access problems.  (#38067)

* Sun Aug 12 2007  Ulrich Weigand  <uweigand@de.ibm.com>  4.1.1-100
- Fix PR 36596 fix.

* Fri Aug 10 2007  Sa Liu  <saliu@de.ibm.com>  4.1.1-99
- Fix PR 36205 Always generate inline code for DP scalar compare

* Fri Aug 10 2007  Sa Liu  <saliu@de.ibm.com>  4.1.1-98
- Fix PR 36596 pointer of vector type should call build_qualified_type()
  to retain qualifiers of base type.

* Thu Aug 9 2007  Ira Rosen  <irar@il.ibm.com>  4.1.1-97
- Fix PR 35978 - remove calls to copy_vitual_operands().  

* Wed Aug 8 2007  Jack Miller  <miller9@us.ibm.com>  4.1.1-96
- Add forced eviction test case.

* Wed Aug 8 2007  Sa Liu  <saliu@de.ibm.com>  4.1.1-95
- Fix DFmode compare with code GE or LE and operand of NaN values. (#37100)

* Wed Aug 8 2007  Sa Liu  <saliu@de.ibm.com>  4.1.1-94
- For DFmode compare, move all special casing from spu_emit_branch_or_set 
  into expander ceq_df and cgt_df.

* Wed Aug 8 2007  Sa Liu  <saliu@de.ibm.com>  4.1.1-93
- Relink REG_LIBCALL and REG_RETVAL insns after split.  

* Wed Aug 8 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-92
- Handle expand_expr being called with __ea pointers from ivopts.

* Tue Aug 7 2007  Jack Miller  <miller9@us.ibm.com>  4.1.1-91
- Remove cache casting hack.
- Remove unnecessary test defines.

* Mon Aug 6 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-90
- A similar fix for integer constants.

* Fri Aug 3 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-89
- Fix casts to/from integral types when size of an __ea pointer is
  greater than the size of the native pointer type.

* Tue Jul 31 2007  Alan Modra  <amodra@au.ibm.com>  4.1.1-88
- Fix __ea ENABLE_CHECKING internal compiler error and don't use inline
  ea code sequence at -O0.  #36791

* Mon Jul 30 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-87
- Ensure casts to/from __ea void pointers are not useless conversions.
  (#36443)

* Sun Jul 29 2007  Victor Kaplansky <victork@il.ibm.com>  4.1.1-86
- Enable store sinking by the default.

* Fri Jul 27 2007  Jack Miller  <miller9@us.ibm.com>  4.1.1-85
- Add cache test to testsuite.

* Thu Jul 26 2007  Jack Miller  <miller9@us.ibm.com>  4.1.1-84
- Fix cache dirty bit clearing.

* Mon Jul 16 2007  Jack Miller  <miller9@us.ibm.com>  4.1.1-83
- Fix cache LS passthru.

* Sat Jul 14 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-82
- Build with --disable-checking.

* Wed Jul 11 2007  Ulrich Weigand  <uweigand@de.ibm.com>  4.1.1-81
- Do not reduce PARAM_MAX_COMPLETELY_PEEL_TIMES if -fpeel-loops or
  -funroll-loops is present on the command line.

* Tue Jul 10 2007  Ulrich Weigand  <uweigand@de.ibm.com>  4.1.1-80
- Remove STMP_FIXINC hack now that cross-newlib is installed in the sysroot.

* Mon Jul 9 2007  Victor Kaplansky  <victork@il.ibm.com>  4.1.1-79
- Fix degradation caused by store-sinking in viterbi of EEMBC.

* Mon Jul 9 2007  Jack Miller  <miller9@us.ibm.com>  4.1.1-78
- Fix cache breakage in -77, fix cache compile with -Werror

* Sun Jul 8 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-77
- Both __ea pointer modes are TARGET_VALID_POINTER_MODEs.
- Fix cache lookups for 64-bit __ea addresses (#36096).

* Sat Jul 7 2007  Jack Miller  <miller9@us.ibm.com>  4.1.1-76
- Fix/simplify miscalculated constant.

* Fri Jul 6 2007  Jack Miller  <miller9@us.ibm.com>  4.1.1-75
- Fix cache_fetch returning ptr inside cache line.

* Wed Jul 4 2007  Alan Modra  <amodra@au1.ibm.com>  4.1.1-74
- Reserve mfc tag 0 for the overlay manager.

* Tue Jul 3 2007  Ira Rosen  <irar@il.ibm.com>  4.1.1-73
- Fix a bug in SLP.

* Mon Jul 2 2007  Jack Miller  <miller9@us.ibm.com>  4.1.1-72
- Cache flush after SPU program finishes.

* Mon Jul 2 2007 Tehila Meyzels  <tehila@il.ibm.com>  4.1.1-71
- Add support for modulo-scheduling of unrolled loops.

* Fri Jun 29 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-70
- Roll forward to gcc-r840.tar.bz2.
- Remove gcc-vect-costmodel.diff.
- Remove fuzz from no-timode.diff.
- Renumber patch series.

* Thu Jun 28 2007  Jack Miller  <miller9@us.ibm.com>  4.1.1-69
- Another round of cache fixes.

* Thu Jun 28 2007  Ulrich Weigand  <uweigand@de.ibm.com>  4.1.1-68
- Add mappings for new PPU VMX intrinsics to vmx2spu (#35876).

* Wed Jun 27 2007  Jack Miller <miller9@us.ibm.com>  4.1.1-67
- EA64 cache fix.

* Wed Jun 27 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-66
- Refresh pointer-cast.diff patch (and bump release number).

* Wed Jun 27 2007  Ira Rosen  <irar@il.ibm.com>  4.1.1-65
- Add SLP support.

* Tue Jun 26 2007  Jack Miller  <miller9@us.ibm.com>  4.1.1-64
- Correct cache casting.

* Mon Jun 26 2007  Victor Kaplansky  <victork@il.ibm.com>  4.1.1-63
- Add store-sinking pass.

* Mon Jun 25 2007  Jack Miller  <miller9@us.ibm.com>  4.1.1-62
- Convert cache to true __ea void *
- Support for resolving internal LS addresses.
- Better tag usage.

* Mon Jun 25 2007  Dorit Nuzman  <dorit@il.ibm.com> 4.1.1-61
- Backport vectorizer cost model from mainline and autovect-branch.

* Fri Jun 22 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-60
- Some parser fixes.

* Thu Jun 21 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-59
- Initial support for casting between __ea and non-__ea pointers.

* Thu Jun 21 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-58
- Enable multilibs.

* Thu Jun 21 2007  Alan Modra  <amodra@au1.ibm.com>  4.1.1-57
- Mark __ea mems with their own alias set.

* Wed Jun 20 2007  Jack Miller  <miller9@us.ibm.com>  4.1.1-56
- Unrevert changes to cache.diff +fixes.

* Wed Jun 20 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-55
- From Alan Modra <amodra@au1.ibm.com>:
  Add ea-backend.diff.

* Tue Jun 19 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-54
- Add ea-dwarf.diff.

* Mon Jun 18 2007  Ulrich Weigand  <uweigand@de.ibm.com>  4.1.1-53
- Update MFC tag manager.

* Mon Jun 18 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-52
- Roll forward to gcc-r833.tar.bz2.
- Remove gcc-vect-outerloop.diff.

* Sun Jun 14 2007  Dorit Nuzman  <dorit@il.ibm.com> 4.1.1-51
- Backport outer-loop vectorization from mainline and autovect-branch.
- Fix ea-frontend.diff.

* Tue Jun 12 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-50
- Pass --target to test_installed when running tests.

* Tue Jun 12 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-49
- Add ea-frontend.diff (not yet complete).

* Sun Jun 10 2007  Ulrich Weigand  <uweigand@de.ibm.com>  4.1.1-48
- Add MFC tag manager.

* Thu Jun 7 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-47
- Roll forward to gcc-r828.tar.bz2.
- Remove cell-exp.diff, argv.diff, fix-finite.diff.
- Refresh bigspu.diff.
- Renumber patch series.

* Mon Jun 4 2007  Ulrich Weigand  <uweigand@de.ibm.com>  4.1.1-46
- Fix #35014 - __builtin_expect regressions.

* Mon Jun 4 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-45
- Some libiberty bug fixes.

* Fri Jun 1 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-44
- Always install DejaGnu board files into /usr/share/dejagnu/baseboards.

* Thu May 31 2007  Sa Liu  <saliu@de.ibm.com>  4.1.1-43
- Fix patterns of dfcmeq and dfcmgt to have them been matched automatically.  

* Wed May 30 2007  Sa Liu  <saliu@de.ibm.com>  4.1.1-42
- Fix #27318 - RFC00056 - handling single-precision arguments that are
  denormals or -0.0
- Backport finite from mainline.

* Mon May 29 2007  Sa Liu  <saliu@de.ibm.com> 4.1.1-41
- Fix #34838 - celledp intrinsics change sign of input parameters.
- Fix cmgt_v2df pattern.

* Fri May 18 2007  Ulrich Weigand  <uweigand@de.ibm.com>  4.1.1-40
- Change cross-prefix to /opt/cell/toolchain.  Do not change sysroot.
- Change group tag to "Cell Development Tools".

* Thu May 17 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-39
- Roll forward to gcc-r798.tar.bz2.
- Remove pr34328.diff.
- Renumber patch series.

* Mon May 14 2007  Tehila Meyzels  <tehila@il.ibm.com>  4.1.1-38
- Fix #32917 - ICE in EEMBC/matrix01 benchmark, caused by a bug in 
  modulo-sched.c.
- Also add missing initialization of bitmap (caused bootstrap failure on ppc).

* Mon May 7 2007  Ulrich Weigand  <uweigand@de.ibm.com>  4.1.1-37
- Fix #34337 - performance regression caused by safe-hints patch.

* Wed May 2 2007 Sa Liu  <saliu@de.ibm.com>  4.1.1-36
- Fix #34328. Add soma builtins to the sony merge backend.

* Mon Apr 30 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-35
- Update cell-exp.diff, install cell-native.exp and cell-remote.exp.

* Fri Apr 27 2007  Sa Liu  <saliu@de.ibm.com>  4.1.1-34
- Switch off TImode again to run fortran testcases.

* Fri Apr 20 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-33
- Roll forward to gcc-r779.tar.bz2.
- Remove Source1 directive (gcc-fortran-4.1.1.tar.bz2).
- Remove associated shell scripts to handle auxillary Fortran tarball.
- Remove redundant patches.

* Fri Apr 13 2007  Sa Liu  <saliu@de.ibm.com>  4.1.1-32
- Add absdf2 to spu backend.

* Thu Apr 12 2007  Sa Liu  <saliu@de.ibm.com>  4.1.1-31
- Fix fortran frontend bugs.

* Tue Apr 10 2007  Ulrich Weigand  <uweigand@de.ibm.com>  4.1.1-30
- Fix #33778 (missing si_bisled* intrinsics).

* Wed Apr 4 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-29
- Do not configure with --disable-werror, as this option only makes
  sense for compilers that can be bootstrapped.

* Mon Apr 2 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-28
- Run test_installed with absolute paths to the installed compilers.

* Wed Mar 28 2007 Sa Liu  <saliu@de.ibm.com>  4.1.1-27
- Set option -mno-safe-hints as default on celledp target.

* Tue Mar 27 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-26
- Install test_installed in the share tree, not bin.
- Update the runtests script to use it.

* Mon Mar 26 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-25
- Include a DejaGnu baseboard file (cell.exp) in the package.
- Extend spu-gcc-runtests to handle native or remote testing.

* Mon Mar 26 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-24
- Exclude the Fortran changelogs.
- Patch test_installed as is done for ppu-gcc.
- Pass --with-gfortran to test_installed to test gfortran.

* Fri Mar 23 2007  Sa Liu  <saliu@de.ibm.com>  4.1.1-23
- Add Fortran frontend and library.

* Thu Mar 22 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-22
- Add testsuite sub-package.
- Copy the GCC testsuite from the source tree to the share directory.
- Create a spu-gcc-runtests wrapper around test_installed.

* Wed Mar 21 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-21
- Roll forward to gcc-r767.tar.bz2. Remove some more local patches.

* Tue Mar 20 2007  Ulrich Weigand  <uweigand@de.ibm.com>  4.1.1-20
- Enable --enable-checking.  Fix build breaks due to duplicate
  definitions.  Fix failed assertion due to rfc00067.diff.

* Tue Mar 20 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-19
- Do not include -DBPA in $CC.

* Tue Mar 20 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-18
- Roll forward to gcc-r762.tar.bz2.  Remove pr30590-fix.diff.

* Fri Mar 16 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-17
- Simplify the filenames of local patches.

* Wed Mar 14 2007  Ulrich Weigand  <uweigand@de.ibm.com>  4.1.1-16
- Backport mainline fix to GCC bugzilla #30590.

* Wed Mar 14 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-15
- Roll forward to gcc-r759.tar.bz2.  Remove some patches.

* Mon Mar 12 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-14
- Remove Patch1 ("toolchain-build-revert.diff"). Renumber patches.
- Remove prep script to set up a combined tree.
- Configure using ../toolchain/gcc/configure, not ../src/configure.

* Thu Mar 8 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-13
- Reintroduce toolchain-rfc00067.diff patch.

* Thu Mar 8 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-12
- Do not package include/syslimits.h after all.

* Thu Mar 8 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-11
- Reintroduce required local patches.

* Thu Mar 8 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-10
- Switch to gcc-r747.tar.bz2 sources.
- Remove all local patches.

* Wed Feb 28 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-9
- Fix flow graph bug that bloats coverage instrumentation (LTC #31184).

* Tue Feb 20 2007  Ulrich Weigand  <uweigand@de.ibm.com>  4.1.1-8
- Fix overloaded intrinsics handling (LTC #30221).

* Fri Feb 16 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-7
- Remove duplicated code generated by -fstack-check.

* Fri Feb 2 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-6
- Change name from spu-toolchain to spu-gcc.
- Remove spu-gcc sub-package.

* Thu Feb 1 2007  Sa Liu <saliu@de.ibm.com>  4.1.1-5
- Add test cases for celledp and backport the exp file for target spu.

* Fri Jan 26 2007  Sa Liu <saliu@de.ibm.com>  4.1.1-4
- Add support for vector conditional expression.

* Fri Jan 26 2007  Sa Liu <saliu@de.ibm.com>  4.1.1-3
- Add celledp support.

* Mon Jan 22 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-2
- Change the cross-prefix to /opt/cell.

* Fri Jan 19 2007  Ben Elliston  <bje@au.ibm.com>  4.1.1-1
- Remove spu_version macro. Update Source0 directive.
- Use %{gcc_version} for the package version.
- Add spu-newlib to BuildRequires packages.

* Tue Jan 16 2007  Ben Elliston  <bje@au.ibm.com>  3.4-6
- Remove the spu-newlib package.

* Fri Jan 12 2007  Ulrich Weigand  <uweigand@de.ibm.com>  3.4-5
- Change sysroot location to /opt/cell/toolchain.

* Fri Jan 12 2007  Ben Elliston  <bje@au.ibm.com>  3.4-4
- No need to remove {dlltool,nlmconv,windres} man pages.

* Fri Jan 12 2007  Ben Elliston  <bje@au.ibm.com>  3.4-3
- Remove all traces of binutils from this spec file.
- Have the package BuildRequire spu-binutils.

* Thu Jan 11 2007  Ben Elliston  <bje@au.ibm.com>  3.4-2
- Place patches in sequential order.

* Thu Jan 11 2007  Ben Elliston  <bje@au.ibm.com>  3.4-1
- Use sources from toolchain-3.4-src.tar.bz2, pruned from 3.3.
- Use binutils sources from an FSF snapshot.
- Remove most local binutils patches.

* Wed Jan 10 2007  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-105
- Remove GDB, this is now a stand-alone package.

* Tue Jan 2 2007  Joel Schopp  <jschopp@austin.ibm.com>
- Update to newlib version 1.15.0.

* Thu Dec 11 2006  Markus Deuling <deuling@de.ibm.com> 3.3-104
- Implement SPU-specific vector type (#29772)

* Fri Dec 8 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-103
- Fix segfault on certain vector initializers (LTC #30136).

* Mon Dec 4 2006  Ben Elliston  <bje@au.ibm.com>  3.3-102
- Provide a prototype for builtin_function to avoid truncating its
  return value on 64-bit hosts.

* Fri Dec 1 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-101
- From Alan Modra <amodra@au1.ibm.com>:
  Add new SOMA instructions to binutils.
 
* Fri Dec 1 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-100
- Start of SDK 2.1 release cycle.  Bump version.

* Tue Nov 21 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-72
- Fix a segfault on closing archives (nm --print-armap).

* Mon Nov 20 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-71
- ibm28945 looping in map_segments.  Backport lang_size_sections code
  from mainline binutils to set section lmas correctly.

* Sat Nov 18 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-70
- ibm29389 backport 2.17 handling of ADDR() in linker scripts for linux kernel

* Thu Nov 16 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-69
- Fix broken epilog in functions calling alloca (#29346).

* Thu Nov 16 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-68
- GDB: Terminate backtrace at entry function (#29298).

* Tue Nov 14 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-67
- ibm28987 Largefile support.

* Mon Nov 13 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-66
- fix non-zero vma in note section.
- ibm29099 gas/1118 fix clash between --alternate and -al=file

* Wed Nov 8 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-65
- Adapt embedspu script to work with shared SPU/PPU prefix (#29064).

* Tue Nov 7 2006 Sa Liu <saliu@de.ibm.com> 3.3-64
- SPU GCC saves and restores stack pointer in block scope.

* Tue Nov 7 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-63
- Add back BuildRoot to allow rebuilding the SRPM.

* Mon Nov 6 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-62
- Implement TWG RFC 00076-0 (double-precision FP_CONTRACT default).

* Sun Nov 5 2006  Dorit Nuzman  <dorit@il.ibm.com>  3.3-61
- Fix and re-enable empty latch blocks patch

* Fri Nov 3 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-60
- Disable empty latch blocks patch due to wrong-code bugs.

* Thu Nov 3 2006 Sa Liu <saliu@de.ibm.com> 3.3-59
- Call macro C_COMMAND_OVERRIDE_OPTIONS to disable warnings
  about non-standard "main" function on SPU.

* Wed Nov 1 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-58
- ppu binutils merge.

* Tue Oct 31 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-57
- Fix sysrooted startfile search path on SPU.

* Tue Oct 31 2006  Tehila Meyzels  <tehila@il.ibm.com>  3.3-56
- Add empty latch blocks patch.

* Fri Oct 27 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-55
- Finish implementation of GDB SPE enhancements.

* Fri Oct 27 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-54
- ppu binutils merge

* Tue Oct 24 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-53
- Use common PPU/SPU sysroot for the cross-toolchain.
- Change cross-prefix to /opt/cell/toolchain-3.3 (no /spu).

* Mon Oct 23 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-52
- Fix FLT_MIN/FLT_MAX problem (RFC 00067, LTC #27347).

* Mon Oct 23 2006 Tehila Meyzels <tehila@il.ibm.com> 3.3-51
- Implement an emulation of BCT instruction to enable doloop analysis
  and transformations.
- Change doloop_modify to copy the COND_BR_PROB to the newly created 
  jump instruction. This is used to generate correct hints for the BCT loops.
- Modifies the profitability check of the SMS
- Add computation of the scheduling windows to prevent register moves.

* Sun Oct 22 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-50
- Add GDB SPE enhancements, refactor GDB patches.

* Fri Oct 20 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-49
- ppu binutils merge.
- Cosmetic changes to spu function name

* Thu Oct 19 2006  Ben Elliston  <bje@au.ibm.com>  3.3-48
- GCC vector initialiser fixes for some installed headers.

* Fri Oct 13 2006  Ben Elliston  <bje@au.ibm.com>  3.3-47
- Switch to GCC-style vector initialisers in some libgcc routines.
- Update newlib sources, too.

* Thu Oct 12 2006  Ben Elliston  <bje@au.ibm.com>  3.3-46
- Remove support for parenthesised vector initialisers.

* Tue Oct 10 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-45
- Ignore zero size sections when checking spu local store limits.

* Mon Oct 9  2006  Dorit Nuzman  <dorit@il.ibm.com>  3.3-44
- Fix vectorizer testcase failures.

* Mon Oct 9 2006  Ben Elliston  <bje@au.ibm.com>  3.3-43
- Make gcc.c-torture/execute/builtins/strlen.c robust against strcpy
  implementations that call strlen.

* Fri Oct 6 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-42
- Fix missing generated file in binutils-config.diff.

* Fri Oct 6 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-41
- Fix .note.spu_name

* Fri Oct 6 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-40
- ppu binutils merge.

* Fri Sep 29 2006  Ben Elliston  <bje@au.ibm.com>  3.3-39
- Bring over Altivec keyword fix from the PPU compiler.

* Thu Sep 28 2006  Markus Deuling  <deuling@de.ibm.com>  3.3-38
- Add gdb long double fix

* Thu Sep 28 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-37
- Prevent overlay stubs on user supplied overlay manager functions.

* Thu Sep 28 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-36
- Add ld dependency on gas, for combined tree make -j

* Wed Sep 27 2006  Ben Elliston  <bje@au.ibm.com>  3.3-35
- Import second batch of testsuite fixes.

* Wed Sep 27 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-34
- Fix --enable-targets=all build when 32-bit host and target.
- For overlays, warn on calls to non-function syms.
- Build spu_ovl.o even when not maintainer mode.

* Tue Sep 26 2006  Ben Elliston  <bje@au.ibm.com>  3.3-33
- Implement TWG RFC 00065-0 (volatile scratch registers).

* Tue Sep 26 2006  Dorit Nuzman  <dorit@il.ibm.com>  3.3-32
- Add flag to limit vectorization to loops with large enough loop bound.

* Tue Sep 26 2006  Ben Elliston  <bje@au.ibm.com>  3.3-31
- XFAIL compat tests that produce relocation overflows.

* Tue Sep 26 2006  Alan Modra  <amodra@au1.ibm.com>  3.3-30
- Add ld build dependency on gas
- Correct typo in md_apply_fix3 that caused trashed opcode field on lqd/stqd.

* Mon Sep 25 2006  Ben Elliston  <bje@au.ibm.com>  3.3-29
- Add Alan's fixes9 patch:
  * Replace SPU_GLOB_DAT with SPU_ADDR32.
  * Reenable gc-sections.
  * Stop --extra-overlay-stubs generating unneccesary intra-segment stubs.

* Sun Sep 24 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-28
- Update spu-gdb to GDB 6.5 base version.

* Fri Sep 22 2006  Ben Elliston  <bje@au.ibm.com>  3.3-27
- Pass -E to patch(1) when applying patch #27.

* Fri Sep 22 2006  Ben Elliston  <bje@au.ibm.com>  3.3-26
- Import the first set of testsuite fixes.

* Wed Sep 20 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-25
- Add Alan's drop9 binutils patch:
  * Add ADDR32 and REL32 relocs
  * Fix makefile readelf dependency
  * Accept SPU_RdEventMask, not SPU_RdEventStatMask
  * Fix segfault on binary output
  * Overlay manager backchain fixes.  Two bugs.
  * Formatting in spu-dis.c

* Wed Sep 20 2006  Ben Elliston  <bje@au.ibm.com>  3.3-24
- Do not link with -lc_p when the compiler driver is passed -pg.

* Tue Sep 19 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-23
- Add Alan's drop8 binutils patch:
  * lots of formatting and general code cleanup
  * fix handling of BFD_RELOC_{8,16,32,64} so that .byte, .short, long,
    .quad work with expressions containing forward references.
  * say we don't need broken word handling
  * update input-file.c to mainline error messages.

* Tue Sep 19 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-22
- Implement TWG RFC 00053-0 (change mfc_list_element.size bitfield size).
- Implement TWG RFC 00062-0 (change "read event mask" channel mnemonic).
- Remove toolchain-mfcio-stdint.diff hack.

* Tue Sep 19 2006 Sa Liu <saliu@de.ibm.com> 3.3-21
- Switch off TImode support in spu gcc backend.
  Replace word_mode by fast_mode in testsuites. 

* Mon Sep 18 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-20
- Change cross-prefix to /opt/cell (from /opt/sce).

* Sun Sep 17 2006  Dorit Nuzman    <dorit@il.ibm.com>     3.3-19
- Backport vectorization of reduction-patterns from mainline and
  vectorization of multiple data-types and type-conversions from autovect-branch.
- Model vector widening multiplication (high/low and even/odd).  

* Fri Sep 15 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-18
- Backport GDB fix allowing section start address of zero.

* Fri Sep 15 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-17
- Update intrinsic mapping header files to Dan's latest revision.

* Fri Sep 15 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-16
- Add Alan's drop6 and drop7 binutils patches:
  * Rewrite the overlay manager support to automate build from source.
  * Don't support spu by default for powerpc.  (use --enable-targets=spu-elf
    if you want spu support.)
  * Fix some testsuite failures.
  * Allow user supplied __ovly_load again, and as a weak sym.
  * Error out on missing gas input file.
  * Build fix.

* Tue Sep 12 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-15
- Add backport of GCC bugzilla #28862 (LTC #25516).

* Tue Sep 12 2006 Sa Liu <saliu@de.ibm.com> 3.3-14
- Add cleanup patch to separate C/C++ specific code from that
  for common frontend.

* Tue Sep 12 2006  Ben Elliston  <bje@au.ibm.com>  3.3-13
- Add testsuite jumbo patch to remove erroneous XFAILs.

* Tue Sep 12 2006  Ben Elliston  <bje@au.ibm.com>  3.3-12
- Use configure-time tests to determine if libstdc++ can be built with
  -ffunction-sections -fdata-sections.

* Tue Sep 5 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-11
- Add Alan's drop4 and drop5 binutils patches:
  * .interrupt section support and .text start at zero
  * stub symbol name changes
  * simple VMA range checks

* Tue Sep 5 2006 Sa Liu <saliu@de.ibm.com> 3.3-10
- Add patch for crt0 formalization.

* Mon Sep 5 2006  Dorit Nuzman  <dorit@il.ibm.com>	  3.3-9
- Support auto-vectorization of misaligned loads.

* Fri Sep 1 2006  Ben Elliston  <bje@au.ibm.com>  3.3-8
- Patch in regenerated libstdc++ Makefile.in files.

* Wed Aug 30 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-7
- More fixes to binutils overlay support.

* Mon Aug 28 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-6
- Fixes to binutils/GDB overlay support.

* Sat Aug 26 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-5
- Add GDB overlay support.

* Fri Aug 25 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-4
- Fix incorrect DWARF debug info (#26634).

* Thu Aug 24 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-3
- Fix incorrect _ovly_table-16 reloc in __ovly_copy.

* Mon Aug 21 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.3-2
- Add Alan's spu binutils rework, including overlay support.
- Fix unwind headers word_mode/fast_mode mismatch bug.
- Re-enable libstdc++ build, do not build/package gprof.

* Fri Aug 18 2006  Markus Deuling  <deuling@de.ibm.com>  3.3-1
- Individual BuildRoot for each user from Makefile to support multiple users on a host 

* Wed Aug 16 2006  Ben Elliston  <bje@au.ibm.com>  3.3-1
- Bump package version number.

* Wed Aug 16 2006  Ben Elliston  <bje@au.ibm.com>  3.2-12
- Update gcc_version and %description.
  Do not build or package libstdc++.
  Package gprof and its man page.

* Mon Aug 14 2006  Ben Elliston  <bje@au.ibm.com>  3.2-11
- Remove unnecessary patches: toolchain-libiberty-merge.diff,
  toolchain-convertible-revert.diff.

* Tue Jul 25 2006 Sa Liu <saliu@de.ibm.com> 3.2-10
- Add option -mfixed-range to SPU GCC.

* Thu Jul 18 2006 Sa Liu <saliu@de.ibm.com> 3.2-9
- Fix a bug of user specified alignment in SPU GCC.
  Fix inaccurate floating point division.

* Thu Jul 13 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.2-8
- Update to newlib version 1.14.0.

* Mon Jul 10 2006  Patrick Mansfield <patmans@us.ibm.com> 3.2-7
- Add support for embedspu.sh handling of the special variable _EAR_ for
  overlay support.

* Sun Jul 2 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.2-6
- Fixes for 64-bit PPE application support.

* Mon Jun 19 2006  Markus Deuling  <deuling@de.ibm.com>  3.2-6
- Add gdb.asm testcases to spu-gdb.

* Fri Jun 09 2006  Sa Liu  <saliu@de.ibm.com>  3.2-5
- Fix bugs in newlib setjmp and longjmp.

* Wed May 24 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.2-4
- Add support for cross-toolchain build.

* Wed May 17 2006  Markus Deuling  <deuling@de.ibm.com>  3.2-3
- Fix broken CELL LOCAL changes.

* Mon May 8 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.2-2
- Bump version.

* Thu Apr 25 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.2-1bb1
- Update to SCEA toolchain release 3.2.

* Tue Mar 28 2006  Ulrich Weigand  <uweigand@de.ibm.com>  3.0-20060124bb1
- Update to SCEA 20060124 GCC 4.0.2 toolchain snapshot.
- Add spu-gdbserver support.
- Remove gdb support for pre-SDK 1.0 experimental kernels.

* Fri Feb 10 2006  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-2be6
- Fix incorrect REG_EQUAL note hoists by loop.c.

* Wed Nov 23 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-2be5
- Fix HBR relocation overflow due to ignored jump table sizes.

* Wed Nov 23 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-2be4
- When attaching to a running SPE thread, extract ELF image from memory.

* Thu Nov 10 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-2be3
- Enable attaching spu-gdb to running SPE threads.

* Thu Nov 3 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-2be2
- Fix build problems on FC 4.

* Wed Oct 26 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-2be1
- Move to CVS head and adapt make logic.

* Fri Oct 21 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-be11_3_5
- Add CESOF support to spu-binutils and embedspu script.
- Build with -DBPA for binutils.

* Sun Oct 9 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-be11_3_4
- Handle inferior startup in spu-gdb without libspe SPU_PTRACE_ME support.

* Thu Oct 6 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-be11_3_3
- Fix C++ library header file install location.
- Fix embedspu script to generate spe_program_header_t headers.

* Tue Oct 4 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-be11_3_2
- Update to SCEA toolchain version 2.3+.

* Fri Sep 9 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-1be8
- Cope with circular dependency between libc.a and libgloss.a.
- Deactivate printf-dependent GDB test case.

* Fri Sep 9 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-1be7
- Replace JSRE newlib by IBM implementation.  Add -lgloss to
  default compiler LIB_SPEC.

* Fri Sep 2 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-1be6
- Update GDB to understand 'read', 'ioctl', and 'spu_run' calls.

* Fri Aug 26 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-1be5
- Update GDB to understand 'read' instead of 'ioctl' on run file.

* Thu Aug 25 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-1be4
- Do not build libgloss.  Remove -lsim from default LINK_SPEC.
- Fix ODT g9739 (ICE on large stack frames).

* Fri Aug 12 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-1be3
- Use embedspu script from SCEA tarball.
- Rename ODT g6218 fix.

* Fri Aug 12 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-1be2
- Add toolchain-trampoline-sync.diff.

* Tue Aug 9 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.3-1be1
- Update to SCEA toolchain version 2.3.

* Thu Jul 15 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.2-1be4
- Add spu-gdb package.

* Thu Jul 15 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.2-1be3
- Fix ODT g6218.

* Thu Jun 9 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.2-1be2
- Add embedspu script to spu-binutils RPM.

* Fri May 27 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.2-1be1
- Update to SCEA toolchain version 2.2.

* Mon Apr 18 2005  Ulrich Weigand  <uweigand@de.ibm.com>  2.1-1be1
- Initial version of spu-toolchain RPM based on SCEA toolchain
  version 2.1.

